
extern char hware_outdat;


void hware_command(void)
{
#if RUSAGE_OLD == TRUE
int local_workload_counter;
#endif
#if OSNUM == OSNUM_LINUX
clear_thread_times(THREAD_HWARE_COMMAND);
#endif
#if RUSAGE_OLD == TRUE
local_workload_counter=workload_counter;
#endif
thread_status_flag[THREAD_HWARE_COMMAND]=THRFLAG_ACTIVE;
while(!kill_all_flag && 
         thread_command_flag[THREAD_HWARE_COMMAND]==THRFLAG_ACTIVE)
  {
  lir_sleep(30000);
#if RUSAGE_OLD == TRUE
  if(local_workload_counter != workload_counter)
    {
    local_workload_counter=workload_counter;
    make_thread_times(THREAD_HWARE_COMMAND);
    }
#endif
  while(hware_flag != 0)
    {
    control_hware();
    lir_sleep(3000);
    }
  }
thread_status_flag[THREAD_HWARE_COMMAND]=THRFLAG_RETURNED;
while(!kill_all_flag &&
            thread_command_flag[THREAD_HWARE_COMMAND] != THRFLAG_NOT_ACTIVE)
  {
  lir_sleep(1000);
  }
}

void set_hardware_tx_frequency(void)
{
switch (ui.soundcard_radio)
  {
  case SOUNDCARD_RADIO_WSE:
  wse_tx_freq_control();
  break;
  }
}

void hware_hand_key(void)
{
int i;
// This routine is called from the rx_input_thread.
// It is responsible for reading the hardware and setting
// hand_key to TRUE or FALSE depending on whether the hand key
// is depressed or not.
// disable the polling of the parallelport when USB2LPT is selected 
// (otherwise  RX OVERRUN ERRORS )
if(( wse.parport != 0 && allow_wse_parport) && wse.parport != USB2LPT16_PORT_NUMBER )
  {
  i=lir_inb(wse_parport_status)&HWARE_MORSE_KEY;
  if(i==0)
    {
    hand_key=TRUE;
    }
  else
    {
    hand_key=FALSE;
    }
  }
}

void hware_set_rxtx(int state)
{
if( wse.parport != 0 && allow_wse_parport)
  {
  lir_mutex_lock();
  if(state == TRUE)
    {
    hware_outdat&=-1-HWARE_RXTX;
    }
  else
    {
    hware_outdat|=HWARE_RXTX;
    }
  lir_mutex_unlock();
  lir_outb(hware_outdat,wse_parport_control);
  }
}

void set_hardware_rx_gain(void)
{
if(diskread_flag >= 2)return;
if(ui.use_extio != 0)
  {
  update_extio_rx_gain();
  return;
  }
if(ui.rx_addev_no == SDR14_DEVICE_CODE)
  {
  fg.gain_increment=10;
  fg.gain/=10;
  fg.gain*=10;
  if(fg.gain > 0)fg.gain=0;
  if(fg.gain<-30)fg.gain=-30;
  sdr_att_counter++;
  return;
  }
if(ui.rx_addev_no == SDRIQ_DEVICE_CODE)
  {
  fg.gain_increment=1;
  if(fg.gain > 0)fg.gain=0;
  if(fg.gain<-36)fg.gain=-36;
  sdr_att_counter++;
  return;
  }
if(ui.rx_addev_no == SDRIP_DEVICE_CODE)
  {
  fg.gain_increment=10;
  fg.gain/=10;
  fg.gain*=10;
  if(fg.gain > 0)fg.gain=0;
  if(fg.gain<-30)fg.gain=-30;
  sdr_att_counter++;
  return;
  }
if(ui.rx_addev_no == PERSEUS_DEVICE_CODE)
  {
  fg.gain_increment=10;
  fg.gain/=10;
  fg.gain*=10;
  if(fg.gain > 0)fg.gain=0;
  if(fg.gain<-30)fg.gain=-30;
  sdr_att_counter++;
  return;
  }
if(ui.rx_addev_no == EXCALIBUR_DEVICE_CODE)
  {
  fg.gain_increment=3;
  fg.gain/=3;
  fg.gain*=3;
  if(fg.gain > 0)fg.gain=0;
  if(fg.gain<-21)fg.gain=-21;
  sdr_att_counter++;
  return;
  }
switch (ui.soundcard_radio)
  {
  case SOUNDCARD_RADIO_WSE:
// bit0 to bit 2 for amplifier/bypass/-10 dB.
// bit0-bit2 = 6 => -10dB
// bit0-bit2 = 3 => 0dB
// bit0-bit2 = 5 => +10dB
//
// bit3 for 5 dB attenuator.
// bit3 = 0 => -5dB
// bit3 = 1 =>  0dB
  wse_rx_amp_control();
  break;

  case SOUNDCARD_RADIO_SI570:
  fg.gain=0;
  break;
  }
}

void set_hardware_rx_frequency(void)
{
float t1;
int i;
if(diskread_flag >= 2)
  {
  sc[SC_WG_FQ_SCALE]++;
  return;
  }
if(ui.use_extio != 0)
  {
  if(fg.passband_increment < 0.0001 || fg.passband_increment > 1.5)
    {   
    fg.passband_increment=0.01;
    }
  if(ui.use_extio < 0)
    {  
    fg.passband_direction = -1;
    }
  else
    {
    fg.passband_direction = 1;
    }      
  fft1_direction = fg.passband_direction;
  update_extio_rx_freq();
  }
if(rx_mode < MODE_TXTEST)users_set_band_no();
if(ui.rx_addev_no == SDR14_DEVICE_CODE ||
   ui.rx_addev_no == SDRIQ_DEVICE_CODE )
  {
  t1=fg.passband_center;
  fg.passband_direction=1;
  if(fg.passband_center > adjusted_sdr_clock)
    {
    i=fg.passband_center/adjusted_sdr_clock;
    t1=fg.passband_center-i*adjusted_sdr_clock;
    }
  if(t1 > 0.5*adjusted_sdr_clock)
    {
    t1=adjusted_sdr_clock-t1;
    fg.passband_direction=-1;
    }
  fg.passband_increment=0.1;
  sdr_nco_counter++;
  goto setfq_x;
  }
/*
if(ui.rx_ad_speed > 550000)
  {
  fg.passband_increment=.25;
  }
else
  {
  if(ui.rx_ad_speed > 260000)
    {
    fg.passband_increment=0.1;
    }
  else
    {
    if(ui.rx_ad_speed > 110000)
      {
      fg.passband_increment=.025;
      }
  else
      {
      fg.passband_increment=.01;
      }
    }
  }  
*/
if(ui.rx_addev_no == SDRIP_DEVICE_CODE)
  {
  fg.passband_direction=1;
  sdr_nco_counter++;
  goto setfq_x;
  }
if(ui.rx_addev_no == PERSEUS_DEVICE_CODE)
  {
  fg.passband_direction=1;
  sdr_nco_counter++;
  goto setfq_x;
  }
if(ui.rx_addev_no == EXCALIBUR_DEVICE_CODE)
  {
  fg.passband_direction=1;
  sdr_nco_counter++;
  goto setfq_x;
  }
switch (ui.soundcard_radio)
  {
  case SOUNDCARD_RADIO_WSE:
  wse_rx_freq_control();
  break;
    
#if LIBUSB_PRESENT == 1
  case SOUNDCARD_RADIO_SI570:
  si570_rx_freq_control();
  break;
#endif
#if LIBSOFT66_PRESENT == 1
  case SOUNDCARD_RADIO_SOFT66:
  soft66_rx_freq_control();
  break;
#endif
  }
setfq_x:;
fg.passband_direction*=ui_converter_direction;  
fft1_direction=fg.passband_direction;
check_filtercorr_direction();
}

